//
//  SFGlobalHotkeyManager.h
//  SFToolkit
//
//  Created by Matteo Rattotti on 7/1/09.
//  Copyright 2009 www.shinyfrog.net. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@interface SFHotkeyObject : NSObject {
    id _target;
    EventHotKeyRef eventHotKeyRef;
    SEL _action;
    unsigned short keycode;
}
@property (nonatomic, readonly) EventHotKeyRef eventHotKeyRef;
@property (nonatomic, readonly) unsigned short keycode;
@property (nonatomic, readonly, retain) id _target;
@property (nonatomic, readonly) SEL _action;

- (id) initWithKeycode: (unsigned short)akeycode eventHotKeyRef: (EventHotKeyRef)aEventHotKeyID target:(id)target action:(SEL) action;

@end

@interface SFGlobalHotkeyManager : NSObject {
    BOOL hasInited;
    NSMutableDictionary *registeredHotkeys;
}

@property (nonatomic, retain, readonly)  NSMutableDictionary *registeredHotkeys;


+ (SFGlobalHotkeyManager *) hotkeyManager;
- (void) unregisterHotkey: (unsigned short) keycode cmdModifier: (BOOL) cmdModifier
                                                controlModifier: (BOOL) controlModifier
                                                 optionModifier: (BOOL) optionModifier
                                                  shiftModifier: (BOOL) shiftModifier;

- (void) registerHotkey: (unsigned short) keycode forSelector: (SEL) selector target: (id) target 
                                                                         cmdModifier: (BOOL) cmdModifier
                                                                     controlModifier: (BOOL) controlModifier
                                                                      optionModifier: (BOOL) optionModifier
                                                                       shiftModifier: (BOOL) shiftModifier;

@end


