//
//  SFHotkeyView.h
//  SFToolkit
//
//  Created by Matteo Rattotti on 6/30/09.
//  Copyright 2009 www.shinyfrog.net. All rights reserved.
//

#import <Cocoa/Cocoa.h>


#define ESCAPE_KEY_VALUE 27
#define RETURN_KEY_VALUE 13
#define TAB_KEY_VALUE 9
#define SPACEBAR_KEY_VALUE 32

#define OPT @"⌥ "
#define CMD @"⌘ "
#define CTRL @"⌃ "
#define SHIFT @"⇧ "
#define RETURN_KEY @"↩ "
#define ESCAPE_KEY  @"⎋ "
#define TAB_KEY  @"⇥ "
#define DELETE_KEY  @"⌫ "
#define UP_ARROW_KEY  @"↑ "
#define DOWN_ARROW_KEY  @"↓ "
#define LEFT_ARROW_KEY  @"← "
#define RIGHT_ARROW_KEY  @"→ "
#define SPACEBAR_KEY @"Space"

#define F1_KEY @"F1"
#define F2_KEY @"F2"
#define F3_KEY @"F3"
#define F4_KEY @"F4"
#define F5_KEY @"F5"
#define F6_KEY @"F6"
#define F7_KEY @"F7"
#define F8_KEY @"F8"
#define F9_KEY @"F9"
#define F10_KEY @"F10"
#define F11_KEY @"F11"
#define F12_KEY @"F12"
#define F13_KEY @"F13"
#define F14_KEY @"F14"
#define F15_KEY @"F15"
#define F16_KEY @"F16"

@protocol SFHotkeyViewDelegate
- (void) hotkeyViewChangedHotkey: (id) sender;
- (void) hotkeyViewRemovedHotkey: (id) sender;
- (void) hotkeyViewWillChangeHotkey: (id) sender;
- (void) hotkeyViewUndoLastChanges: (id) sender;
@end



@interface SFHotkeyView : NSView {
    IBOutlet id _delegate;
    
    BOOL acceptHotkey;
    NSMutableDictionary *registeredHotkey;
    NSMutableDictionary *modifiersHotkey;

    NSColor *borderColor;
	NSGradient *currentButtomGradient;
    NSGradient *inactiveButtomGradient;
	NSGradient *clickedButtomGradient;
	NSGradient *activeButtomGradient;
    
    float currentFontSize;
    float bigFontSize;
    float smallFontSize;
}
 
@property (nonatomic, retain)  NSMutableDictionary *registeredHotkey;

- (void)fillHotkeyDict:(BOOL)cmd alternate:(BOOL)alt control:(BOOL)ctrl shift:(BOOL)shift keycode:(unsigned short)keycode hotkey:(unichar)hotkey;
- (void)fillModifierHotkeyDict:(BOOL)cmd alternate:(BOOL)alt control:(BOOL)ctrl shift:(BOOL)shift;
- (NSString *) renderHotkeyDict: (NSDictionary *) dict;
- (void)setHotkey:(NSEvent *)theEvent;
- (unichar) unicharFromKeycode: (unsigned short) keycode;

@end
