//
//  SFHtmlModal.h
//  SFToolkit
//
//  Created by Matteo Rattotti on 8/31/09.
//  Copyright 2009 www.shinyfrog.net. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "SFSeparatorView.h"


@interface SFHtmlModal : NSObject {
    NSWindow *htmlWindow;
    WebView *htmlWebView;
    NSButton *okButton, *cancelbutton;
    SFEvenSeparatorView *bottomView;
        
    int footerHeight;
}

@property (readonly, nonatomic) NSButton *okButton;
@property (readonly, nonatomic) NSButton *cancelbutton;

+ (int) htmlWindowWithSize: (NSSize) winSize url: (NSURL *) url;
+ (int) htmlWindowWithSize: (NSSize) winSize 
                       url: (NSURL *) url 
           firstButtonText: (NSString *)firstButtonText 
          secondButtonText: (NSString *) secondButtonText
           webViewDelegate: (id)delegate;

- (id) initWithSize: (NSSize) winSize 
                url: (NSURL *) url 
    firstButtonText: (NSString *)firstButtonText 
   secondButtonText: (NSString *) secondButtonText
    webViewDelegate: (id)delegate;

- (int) beginModal;
- (void) endModalWithCode:(int) code;

@end
